package com.iformall.controller;

import com.iformall.domain.vo.WxOrderQueryVo;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.github.pagehelper.PageInfo;
import com.iformall.common.Result;
import com.iformall.common.ResultData;

import com.iformall.domain.po.WxOrder;
import com.iformall.service.WxOrderService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;

import java.util.Map;

@RestController
@RequestMapping("wxOrder")
public class WxOrderController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

	@Autowired
    private WxOrderService wxOrderService;

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "status", value = "订单状态：-1全部;0-已下单/待付款;1-已支付;2-已取消(限定时间内未付款);3-未退款/待退款;4-已退款;5-退款失败", defaultValue = "0", required = false, dataType = "int")
    })
    public ResultData list(@ModelAttribute WxOrder wxOrder, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxOrderController::list");
        if (null == wxOrder) wxOrder = new WxOrder();
        wxOrder.setTenantId(getTenantId());
        wxOrder.setSortColumns(WxOrder.Field.Id_DESC);
        final PageInfo<WxOrder> page = wxOrderService.listAsPage(wxOrder, pageNum, pageSize);
        return new ResultData(page);
    }

	@ApiOperation("新增接口")
    @PostMapping("add")
    public ResultData add(@RequestBody WxOrder wxOrder) {
        logger.debug("[" + getIpAddr() + "] WxOrderController::add");
        //Assert.notNull(wxOrder.getName(), "角色名不能为空");
        //Assert.isTrue(!checkUnique(sysRole.getName(), null), "重复的角色名");
        wxOrderService.saveOrUpdate(wxOrder);
        return new ResultData();
    }

    @ApiOperation("根据id更新接口")
    @PostMapping("update")
    public ResultData update(@RequestBody WxOrder wxOrder) {
        logger.debug("[" + getIpAddr() + "] WxOrderController::update");
        wxOrderService.saveOrUpdate(wxOrder);
        return new ResultData();
    }

    @ApiOperation("根据id删除接口")
    @GetMapping("/del")
     @ApiImplicitParam(name="id",value="id",dataType="Long", paramType = "query",required=true)
    public ResultData delete(Long id) {
        logger.debug("[" + getIpAddr() + "] WxOrderController::delete");
        wxOrderService.deleteById(id);
        return new ResultData(Result.SUCCESS, "删除成功", null);
    }
    
     @ApiOperation("根据id查询接口")
     @GetMapping("/findById")
     @ApiImplicitParam(name="id",value="id",dataType="Long", paramType = "query",required=true)
    public ResultData findById(Long id) {
        logger.debug("[" + getIpAddr() + "] WxOrderController::findById");
        return new ResultData(Result.SUCCESS,"查询成功",wxOrderService.getById(id));
    }


    @ApiOperation("交易列表")
    @GetMapping("listOrder")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)
    })
    public ResultData listOrder(@ModelAttribute WxOrderQueryVo wxOrderQueryVo, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxOrderController::listOrder");
        if (null == wxOrderQueryVo){
            wxOrderQueryVo = new WxOrderQueryVo();
        }
        wxOrderQueryVo.setTenantId(getTenantId());
        final PageInfo<WxOrder> page = wxOrderService.listOrderAsPage(wxOrderQueryVo, pageNum, pageSize);
        return new ResultData(page);
    }

    @ApiOperation("交易统计")
    @GetMapping("/queryOrderSummary")
    public ResultData queryOrderSummary() {
        logger.debug("[" + getIpAddr() + "] WxOrderController::queryOrderSummary");

        Map<String, Object> data = wxOrderService.queryOrderSummary(getTenantId());

        return new ResultData(data);
    }


	
}
